Bug 821127 - Avahi's IPv6 support is disabled by default
Avahi's IPv6 support is disabled by default
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: avahi (Show other bugs)
rawhide
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Lennart Poettering
Fedora Extras Quality Assurance
: FutureFeature
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-05-12 05:55 EDT by Pavel Šimerda (pavlix)
Modified: 2015-10-10 10:28 EDT (History)
8 users (show)

See Also:
Fixed In Version:
Doc Type: Enhancement
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-10-10 09:44:47 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)

  None (edit)
Description Pavel Šimerda (pavlix) 2012-05-12 05:55:01 EDT
avahi-0.6.30-7.fc17.x86_64

from /etc/avahi/avahi-daemon.conf:

use-ipv6=no

This prevents Avahi working with IPv6 where it is even more useful
than in IPv4 thanks to IPv6 link-local addresses. Of course it can be administratively changed but I see no reason to IPv6 disabled by default in 2012.
Comment 1 Pavel Šimerda (pavlix) 2012-05-18 06:28:38 EDT
Note: Avahi's IPv6 support would be even more useful if bug 719178 is also fixed. Then you could use local network services separately from network configuration.
Comment 2 Pavel Šimerda (pavlix) 2012-05-28 22:02:42 EDT
It looks like this bug is the same as bug 195674 fixed six years ago and then reintroduced.
Comment 3 Martin 2012-08-03 14:34:05 EDT
Avahi by Default on the Desktop Feature page for F18: http://fedoraproject.org/wiki/Features/AvahiDefaultOnDesktop

man avahi-daemon.conf:

use-ipv6= Takes a boolean value ("yes" or "no"). If set to "no"  avahi-
       daemon will not use IPv6 sockets. Default is "yes".


I can't find any reason for having Avahi disabled on IPv6.
Comment 4 Stef Walter 2012-08-06 08:32:50 EDT
It looks like this should be fixed upstream, not by patching around it in distros: http://avahi.org/ticket/367
Comment 5 Pavel Šimerda (pavlix) 2012-08-09 08:29:10 EDT
Thanks, Stef. It would be nice to make sure this gets in before Fedora 18 Alpha is out, maybe even through patching in Fedora.
Comment 6 Lennart Poettering 2012-08-09 13:00:33 EDT
So, the problem with this is that we cannot really deduplicate services we find on different networks/protocols. That means a service that is announced via IPv4 and IPv6 will appear twice in a client that browses on both Ipv4 and IPv6.

This has already been a problem when i started working on this and the mDNS/DNS-SD designers have been aware of it. But tbh I haven't checked the current drafts recently to see whether there is now a sane way to deduplicate these things...

Until there is a sane strategy on deduplicating these services I don't think we should enable Ipv6 by default.
Comment 7 Pavel Šimerda (pavlix) 2012-08-12 07:03:24 EDT
Understood. But then it's pretty useless to promote Avahi for modern networking. Funny enough is that Fedora computers always have IPv6 addresses (but nss-mdns doesn't work for IPv6LL) but often don't have IPv4 addresses (e.g. when connected to networks without DHCP configuration or to IPv6 only networks with IPv4 services presented through NAT64.

This will soon make Fedora feel prehistoric, so please tell me if I can be of any help.
Comment 8 Fedora End Of Life 2013-07-03 19:56:44 EDT
This message is a reminder that Fedora 17 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 17. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '17'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 17's end of life.

Bug Reporter:  Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 17 is end of life. If you 
would still like  to see this bug fixed and are able to reproduce it 
against a later version  of Fedora, you are encouraged  change the 
'version' to a later Fedora version prior to Fedora 17's end of life.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 9 mathew 2014-09-11 14:27:13 EDT
Just hit this problem in Fedora 20.

As well as /etc/avahi.conf, IPv6 resolution is turned off in /etc/nsswitch.conf.
Comment 10 Fabian Deutsch 2014-09-12 07:52:12 EDT
(In reply to Lennart Poettering from comment #6)
> So, the problem with this is that we cannot really deduplicate services we
> find on different networks/protocols. That means a service that is announced
> via IPv4 and IPv6 will appear twice in a client that browses on both Ipv4
> and IPv6.
> 
> This has already been a problem when i started working on this and the
> mDNS/DNS-SD designers have been aware of it. But tbh I haven't checked the
> current drafts recently to see whether there is now a sane way to
> deduplicate these things...
> 
> Until there is a sane strategy on deduplicating these services I don't think
> we should enable Ipv6 by default.

Despite the fact that this duplication problem is not solved, I'd also tend to slowly start and enable this feature.

With native IPv6 ISp connectiosn IPv& is - toller weise - popping up more often in user's homes. Thus I'd like to have the same mdns features over IPv6 as I have on IPv4.
Comment 11 Pavel Šimerda (pavlix) 2014-09-12 09:27:56 EDT
(In reply to Fabian Deutsch from comment #10)
> With native IPv6 ISp connectiosn IPv& is - toller weise - popping up more
> often in user's homes. Thus I'd like to have the same mdns features over
> IPv6 as I have on IPv4.

Also link-local addresses work without ISP's IPv6 and I'm talking with glibc devs about enabling proper link-local address resolution via glibc getaddrinfo and nsswitch interface.
Comment 12 mathew 2014-09-12 11:12:53 EDT
In trying to get everything working, I discovered that OpenSSH will fall back to IPv4 even if you have it configured to prefer IPv6 in .ssh/config, and even if you use the -6 flag on the command line. So I don't think the OpenSSH/glibc issue should be a showstopper for enabling IPv6 by default.
Comment 13 Pavel Šimerda (pavlix) 2014-09-12 14:49:20 EDT
(In reply to mathew from comment #12)
> even if you use the -6 flag on the command line

Did you file a bug report with that? I have never seen such a behavior but I'm regularly only using -4.

> So I don't think the
> OpenSSH/glibc issue should be a showstopper for enabling IPv6 by default.

I wasn't aware that anyone would claim any OpenSSH or glibc issue was a showstopper.
Comment 14 mathew 2015-06-02 14:04:21 EDT
Still an issue in a clean install of Fedora 21.
Comment 15 Pavel Šimerda (pavlix) 2015-06-03 04:45:54 EDT
As well as Fedora 22.
Comment 16 Jan Kurik 2015-07-15 11:09:06 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 23 development cycle.
Changing version to '23'.

(As we did not run this process for some time, it could affect also pre-Fedora 23 development
cycle bugs. We are very sorry. It will help us with cleanup during Fedora 23 End Of Life. Thank you.)

More information and reason for this action is here:
https://fedoraproject.org/wiki/BugZappers/HouseKeeping/Fedora23
Comment 17 Rex Dieter 2015-09-17 13:04:59 EDT
marking futurefeature, so this doesn't get autoclosed
Comment 18 Daniel 2015-10-09 21:46:28 EDT
The configuration issue is now fixed upstream in Avahi version 0.6.32. I just asked on IRC for a release with this change and voilá, a release we got.
https://www.aeyoun.com/technote/avahi-ipv6.html
Comment 19 Rex Dieter 2015-10-10 07:57:55 EDT
Have the concerns from comment #6 been addressed?  As far as I can tell, they have not.
Comment 20 Rex Dieter 2015-10-10 09:44:47 EDT
Fwiw, updated rawhide

%changelog
* Sat Oct 10 2015 Rex Dieter <rdieter@fedoraproject.org> - 0.6.32-0.1.rc
- avahi-0.6.32-rc
- -devel: move dbus-1/interfaces here
- Avahi's IPv6 support is disabled by default (#821127)
- avahi: script and/or trigger should not directly enable systemd units (#1094899)

which is a fair venue to at least try the new upstream default.


If anyone(*) feels this should be considered to be merged/backported to f23, feel free to say so and re-open.


(*) bonus if from other avahi maintainers or fedora SIG members (workstation, kde, etc...)
Comment 21 mathew 2015-10-10 10:28:27 EDT
(In reply to Rex Dieter from comment #19)
> Have the concerns from comment #6 been addressed?  As far as I can tell,
> they have not.

Well, the comment was made back in 2012. I would hope that client programs are now a bit smarter about performing deduplication and preferring IPv6 when browsing. Even if they aren't, it seems to me that it's just a cosmetic issue if two working services show up instead of one.

Note You need to log in before you can comment on or make changes to this bug.